searchData={"items":[{"type":"module","title":"VertexCacheSdk","doc":"VertexCacheSdk is the main entry point for interacting with the VertexCache server.\n\nIt provides methods to perform cache operations such as GET, SET, and DEL, and abstracts\naway the underlying TCP transport details.\n\nThis SDK handles encryption (symmetric/asymmetric), TLS negotiation, authentication, and\nframing of commands and responses.","ref":"VertexCacheSdk.html"},{"type":"function","title":"VertexCacheSdk.close/1","doc":"","ref":"VertexCacheSdk.html#close/1"},{"type":"function","title":"VertexCacheSdk.del/2","doc":"","ref":"VertexCacheSdk.html#del/2"},{"type":"function","title":"VertexCacheSdk.get/2","doc":"","ref":"VertexCacheSdk.html#get/2"},{"type":"function","title":"VertexCacheSdk.get_by_secondary_index/2","doc":"","ref":"VertexCacheSdk.html#get_by_secondary_index/2"},{"type":"function","title":"VertexCacheSdk.get_by_tertiary_index/2","doc":"","ref":"VertexCacheSdk.html#get_by_tertiary_index/2"},{"type":"function","title":"VertexCacheSdk.is_connected?/1","doc":"","ref":"VertexCacheSdk.html#is_connected?/1"},{"type":"function","title":"VertexCacheSdk.open_connection/1","doc":"","ref":"VertexCacheSdk.html#open_connection/1"},{"type":"function","title":"VertexCacheSdk.ping/1","doc":"","ref":"VertexCacheSdk.html#ping/1"},{"type":"function","title":"VertexCacheSdk.set/3","doc":"","ref":"VertexCacheSdk.html#set/3"},{"type":"function","title":"VertexCacheSdk.set/4","doc":"","ref":"VertexCacheSdk.html#set/4"},{"type":"function","title":"VertexCacheSdk.set/5","doc":"","ref":"VertexCacheSdk.html#set/5"},{"type":"type","title":"VertexCacheSdk.t/0","doc":"","ref":"VertexCacheSdk.html#t:t/0"},{"type":"module","title":"VertexCacheSdk.Comm.ClientConnector","doc":"Primary SDK transport layer for VertexCache.\n\nHandles TLS, IDENT handshake, framing, and encryption.","ref":"VertexCacheSdk.Comm.ClientConnector.html"},{"type":"function","title":"VertexCacheSdk.Comm.ClientConnector.close/1","doc":"","ref":"VertexCacheSdk.Comm.ClientConnector.html#close/1"},{"type":"function","title":"VertexCacheSdk.Comm.ClientConnector.connect/1","doc":"","ref":"VertexCacheSdk.Comm.ClientConnector.html#connect/1"},{"type":"function","title":"VertexCacheSdk.Comm.ClientConnector.is_connected/1","doc":"","ref":"VertexCacheSdk.Comm.ClientConnector.html#is_connected/1"},{"type":"function","title":"VertexCacheSdk.Comm.ClientConnector.new/1","doc":"","ref":"VertexCacheSdk.Comm.ClientConnector.html#new/1"},{"type":"function","title":"VertexCacheSdk.Comm.ClientConnector.send/2","doc":"","ref":"VertexCacheSdk.Comm.ClientConnector.html#send/2"},{"type":"type","title":"VertexCacheSdk.Comm.ClientConnector.socket/0","doc":"","ref":"VertexCacheSdk.Comm.ClientConnector.html#t:socket/0"},{"type":"type","title":"VertexCacheSdk.Comm.ClientConnector.state/0","doc":"","ref":"VertexCacheSdk.Comm.ClientConnector.html#t:state/0"},{"type":"module","title":"VertexCacheSdk.Comm.GcmCryptoHelper","doc":"AES-GCM helper module for VertexCache SDK (Elixir).\n\nUses AES-256-GCM with a 12-byte IV and 16-byte authentication tag.\nEncrypted payload is: IV || ciphertext || tag","ref":"VertexCacheSdk.Comm.GcmCryptoHelper.html"},{"type":"function","title":"VertexCacheSdk.Comm.GcmCryptoHelper.decode_base64_key/1","doc":"Decodes a base64-encoded key.","ref":"VertexCacheSdk.Comm.GcmCryptoHelper.html#decode_base64_key/1"},{"type":"function","title":"VertexCacheSdk.Comm.GcmCryptoHelper.decrypt/2","doc":"Decrypts an AES-256-GCM encrypted binary of the format IV || ciphertext || tag.","ref":"VertexCacheSdk.Comm.GcmCryptoHelper.html#decrypt/2"},{"type":"function","title":"VertexCacheSdk.Comm.GcmCryptoHelper.encode_base64_key/1","doc":"Encodes a raw binary key as base64.","ref":"VertexCacheSdk.Comm.GcmCryptoHelper.html#encode_base64_key/1"},{"type":"function","title":"VertexCacheSdk.Comm.GcmCryptoHelper.encrypt/2","doc":"Encrypts the given plaintext using AES-256-GCM.\n\nReturns a binary of IV || ciphertext || tag.","ref":"VertexCacheSdk.Comm.GcmCryptoHelper.html#encrypt/2"},{"type":"function","title":"VertexCacheSdk.Comm.GcmCryptoHelper.generate_base64_key/0","doc":"Generates a 256-bit AES key encoded in base64.","ref":"VertexCacheSdk.Comm.GcmCryptoHelper.html#generate_base64_key/0"},{"type":"module","title":"VertexCacheSdk.Comm.KeyParserHelper","doc":"","ref":"VertexCacheSdk.Comm.KeyParserHelper.html"},{"type":"function","title":"VertexCacheSdk.Comm.KeyParserHelper.config_public_key_if_enabled/1","doc":"Parses a PEM-encoded RSA public key and returns a DER binary.\n\nRaises VertexCacheSdkException on failure.","ref":"VertexCacheSdk.Comm.KeyParserHelper.html#config_public_key_if_enabled/1"},{"type":"function","title":"VertexCacheSdk.Comm.KeyParserHelper.config_shared_key_if_enabled/1","doc":"Decodes a Base64-encoded symmetric key into raw bytes.\n\nRaises VertexCacheSdkException on failure.","ref":"VertexCacheSdk.Comm.KeyParserHelper.html#config_shared_key_if_enabled/1"},{"type":"module","title":"VertexCacheSdk.Comm.MessageCodec","doc":"Handles TCP message framing and deframing using VertexCache protocol.\n\nFormat:\n  - 4 bytes big-endian payload length\n  - 4 bytes big-endian protocol version\n  - N bytes payload","ref":"VertexCacheSdk.Comm.MessageCodec.html"},{"type":"function","title":"VertexCacheSdk.Comm.MessageCodec.read_framed_message/1","doc":"Decodes a framed binary from a given binary stream buffer.","ref":"VertexCacheSdk.Comm.MessageCodec.html#read_framed_message/1"},{"type":"function","title":"Returns - VertexCacheSdk.Comm.MessageCodec.read_framed_message/1","doc":"- `{:ok, payload, rest}` if valid\n  - `:error` if header is incomplete\n  - `{:error, reason}` if validation fails","ref":"VertexCacheSdk.Comm.MessageCodec.html#read_framed_message/1-returns"},{"type":"function","title":"VertexCacheSdk.Comm.MessageCodec.write_framed_message/2","doc":"Encodes the given payload as a framed binary.","ref":"VertexCacheSdk.Comm.MessageCodec.html#write_framed_message/2"},{"type":"function","title":"Raises - VertexCacheSdk.Comm.MessageCodec.write_framed_message/2","doc":"- `ArgumentError` if payload exceeds max size.","ref":"VertexCacheSdk.Comm.MessageCodec.html#write_framed_message/2-raises"},{"type":"module","title":"VertexCacheSdk.Comm.SocketHelper","doc":"","ref":"VertexCacheSdk.Comm.SocketHelper.html"},{"type":"function","title":"VertexCacheSdk.Comm.SocketHelper.create_secure_socket/1","doc":"Creates a TLS socket using provided options.\nDelegates TLS config to SSLHelper.","ref":"VertexCacheSdk.Comm.SocketHelper.html#create_secure_socket/1"},{"type":"function","title":"VertexCacheSdk.Comm.SocketHelper.create_socket_non_tls/1","doc":"Creates a non-TLS (plain) TCP socket connection.","ref":"VertexCacheSdk.Comm.SocketHelper.html#create_socket_non_tls/1"},{"type":"behaviour","title":"VertexCacheSdk.Command","doc":"Behaviour for all command modules that can be executed by the VertexCache SDK.\n\nImplementations must define how the command is built and parsed, and return success/error\nstatus based on the response. This abstraction allows consistent handling of commands\n(e.g. GET, SET, DEL, PING) across the SDK.","ref":"VertexCacheSdk.Command.html"},{"type":"callback","title":"VertexCacheSdk.Command.build_command/0","doc":"","ref":"VertexCacheSdk.Command.html#c:build_command/0"},{"type":"callback","title":"VertexCacheSdk.Command.execute/1","doc":"","ref":"VertexCacheSdk.Command.html#c:execute/1"},{"type":"callback","title":"VertexCacheSdk.Command.parse_response/1","doc":"","ref":"VertexCacheSdk.Command.html#c:parse_response/1"},{"type":"module","title":"VertexCacheSdk.Command.CommandBase","doc":"Provides shared helpers for implementing VertexCache SDK commands.\n\nThis module handles:\n- Raw response decoding and success/error detection\n- Default implementations for `parse_response/1`\n- Utility functions for setting command status\n\nCommands can delegate to these helpers to keep their logic clean and testable.","ref":"VertexCacheSdk.Command.CommandBase.html"},{"type":"function","title":"VertexCacheSdk.Command.CommandBase.execute/3","doc":"","ref":"VertexCacheSdk.Command.CommandBase.html#execute/3"},{"type":"module","title":"VertexCacheSdk.Command.CommandType","doc":"Enum-like module representing the different types of commands supported by the VertexCache SDK.\n\nEach command type corresponds to a specific cache operation or internal SDK operation,\nsuch as GET, SET, DELETE, or IDX1/IDX2 (used for secondary/tertiary index lookups).\n\nThis module is used throughout the SDK to identify and validate command behavior,\nfacilitate routing, and enforce permission checks based on role capabilities.","ref":"VertexCacheSdk.Command.CommandType.html"},{"type":"function","title":"VertexCacheSdk.Command.CommandType.keyword/1","doc":"","ref":"VertexCacheSdk.Command.CommandType.html#keyword/1"},{"type":"type","title":"VertexCacheSdk.Command.CommandType.t/0","doc":"","ref":"VertexCacheSdk.Command.CommandType.html#t:t/0"},{"type":"function","title":"VertexCacheSdk.Command.CommandType.to_string/1","doc":"","ref":"VertexCacheSdk.Command.CommandType.html#to_string/1"},{"type":"module","title":"VertexCacheSdk.Command.Impl.DelCommand","doc":"Handles the DEL command in VertexCache.\n\nDeletes a key and its associated value from the cache.\nIf the system is configured to allow idempotent deletes,\nthen attempting to delete a non-existent key will still\nreturn a success response (\"OK DEL (noop)\").\n\nRequires the client to have WRITE or ADMIN access.\n\nConfiguration:\n- `del_command_idempotent`: when true, deletion of missing keys does not result in an error.","ref":"VertexCacheSdk.Command.Impl.DelCommand.html"},{"type":"function","title":"VertexCacheSdk.Command.Impl.DelCommand.build_command/1","doc":"","ref":"VertexCacheSdk.Command.Impl.DelCommand.html#build_command/1"},{"type":"function","title":"VertexCacheSdk.Command.Impl.DelCommand.execute/2","doc":"","ref":"VertexCacheSdk.Command.Impl.DelCommand.html#execute/2"},{"type":"function","title":"VertexCacheSdk.Command.Impl.DelCommand.new/1","doc":"","ref":"VertexCacheSdk.Command.Impl.DelCommand.html#new/1"},{"type":"function","title":"VertexCacheSdk.Command.Impl.DelCommand.parse_response/1","doc":"Callback implementation for  VertexCacheSdk.Command.parse_response/1 .","ref":"VertexCacheSdk.Command.Impl.DelCommand.html#parse_response/1"},{"type":"type","title":"VertexCacheSdk.Command.Impl.DelCommand.t/0","doc":"","ref":"VertexCacheSdk.Command.Impl.DelCommand.html#t:t/0"},{"type":"module","title":"VertexCacheSdk.Command.Impl.GetCommand","doc":"Handles the GET command in VertexCache.\n\nRetrieves the value for a given key from the cache.\nReturns an error if the key is missing or expired.\n\nRequires the client to have READ, READ_WRITE, or ADMIN access.\nThis command supports primary key lookups only.","ref":"VertexCacheSdk.Command.Impl.GetCommand.html"},{"type":"function","title":"VertexCacheSdk.Command.Impl.GetCommand.execute/2","doc":"","ref":"VertexCacheSdk.Command.Impl.GetCommand.html#execute/2"},{"type":"function","title":"VertexCacheSdk.Command.Impl.GetCommand.new/1","doc":"","ref":"VertexCacheSdk.Command.Impl.GetCommand.html#new/1"},{"type":"function","title":"VertexCacheSdk.Command.Impl.GetCommand.parse_response/1","doc":"Callback implementation for  VertexCacheSdk.Command.parse_response/1 .","ref":"VertexCacheSdk.Command.Impl.GetCommand.html#parse_response/1"},{"type":"type","title":"VertexCacheSdk.Command.Impl.GetCommand.t/0","doc":"","ref":"VertexCacheSdk.Command.Impl.GetCommand.html#t:t/0"},{"type":"module","title":"VertexCacheSdk.Command.Impl.GetSecondaryIdxOneCommand","doc":"Handles the GET Secondary Idx (idx1) command in VertexCache.\n\nRetrieves the value for a given key from the cache using a secondary index.\nReturns an error if the key is missing or expired.\n\nRequires the client to have READ, READ_WRITE, or ADMIN access.","ref":"VertexCacheSdk.Command.Impl.GetSecondaryIdxOneCommand.html"},{"type":"function","title":"VertexCacheSdk.Command.Impl.GetSecondaryIdxOneCommand.execute/2","doc":"","ref":"VertexCacheSdk.Command.Impl.GetSecondaryIdxOneCommand.html#execute/2"},{"type":"function","title":"VertexCacheSdk.Command.Impl.GetSecondaryIdxOneCommand.new/1","doc":"","ref":"VertexCacheSdk.Command.Impl.GetSecondaryIdxOneCommand.html#new/1"},{"type":"function","title":"VertexCacheSdk.Command.Impl.GetSecondaryIdxOneCommand.parse_response/1","doc":"Callback implementation for  VertexCacheSdk.Command.parse_response/1 .","ref":"VertexCacheSdk.Command.Impl.GetSecondaryIdxOneCommand.html#parse_response/1"},{"type":"type","title":"VertexCacheSdk.Command.Impl.GetSecondaryIdxOneCommand.t/0","doc":"","ref":"VertexCacheSdk.Command.Impl.GetSecondaryIdxOneCommand.html#t:t/0"},{"type":"module","title":"VertexCacheSdk.Command.Impl.GetSecondaryIdxTwoCommand","doc":"Handles the GET Secondary Idx (idx2) command in VertexCache.\n\nRetrieves the value for a given key from the cache using a tertiary index.\nReturns an error if the key is missing or expired.\n\nRequires the client to have READ, READ_WRITE, or ADMIN access.","ref":"VertexCacheSdk.Command.Impl.GetSecondaryIdxTwoCommand.html"},{"type":"function","title":"VertexCacheSdk.Command.Impl.GetSecondaryIdxTwoCommand.execute/2","doc":"","ref":"VertexCacheSdk.Command.Impl.GetSecondaryIdxTwoCommand.html#execute/2"},{"type":"function","title":"VertexCacheSdk.Command.Impl.GetSecondaryIdxTwoCommand.new/1","doc":"","ref":"VertexCacheSdk.Command.Impl.GetSecondaryIdxTwoCommand.html#new/1"},{"type":"function","title":"VertexCacheSdk.Command.Impl.GetSecondaryIdxTwoCommand.parse_response/1","doc":"Callback implementation for  VertexCacheSdk.Command.parse_response/1 .","ref":"VertexCacheSdk.Command.Impl.GetSecondaryIdxTwoCommand.html#parse_response/1"},{"type":"type","title":"VertexCacheSdk.Command.Impl.GetSecondaryIdxTwoCommand.t/0","doc":"","ref":"VertexCacheSdk.Command.Impl.GetSecondaryIdxTwoCommand.html#t:t/0"},{"type":"module","title":"VertexCacheSdk.Command.Impl.PingCommand","doc":"Handles the PING command in VertexCache.\n\nThis command is used to check server availability and latency.\nIt returns a basic `\"PONG\"` response and can be used by clients to verify liveness.\n\nPING is always allowed regardless of authentication state or client role.\nIt does not require access validation or key arguments.","ref":"VertexCacheSdk.Command.Impl.PingCommand.html"},{"type":"function","title":"VertexCacheSdk.Command.Impl.PingCommand.build_command/0","doc":"Callback implementation for  VertexCacheSdk.Command.build_command/0 .","ref":"VertexCacheSdk.Command.Impl.PingCommand.html#build_command/0"},{"type":"function","title":"VertexCacheSdk.Command.Impl.PingCommand.execute/1","doc":"Callback implementation for  VertexCacheSdk.Command.execute/1 .","ref":"VertexCacheSdk.Command.Impl.PingCommand.html#execute/1"},{"type":"function","title":"VertexCacheSdk.Command.Impl.PingCommand.parse_response/1","doc":"Callback implementation for  VertexCacheSdk.Command.parse_response/1 .","ref":"VertexCacheSdk.Command.Impl.PingCommand.html#parse_response/1"},{"type":"module","title":"VertexCacheSdk.Command.Impl.SetCommand","doc":"Handles the SET command in VertexCache.\n\nStores a value in the cache under the specified key, optionally assigning\nsecondary (`idx1`) and tertiary (`idx2`) indexes for lookup. Existing keys will\nbe overwritten. Supports expiration and format validation if configured.\n\nRequires the client to have WRITE or ADMIN access.\n\nValidation:\n- Primary key and value are required.\n- If secondary index is provided, it must be non-blank.\n- If tertiary index is used, secondary index must also be present and non-blank.","ref":"VertexCacheSdk.Command.Impl.SetCommand.html"},{"type":"function","title":"VertexCacheSdk.Command.Impl.SetCommand.build_command/1","doc":"","ref":"VertexCacheSdk.Command.Impl.SetCommand.html#build_command/1"},{"type":"function","title":"VertexCacheSdk.Command.Impl.SetCommand.execute/2","doc":"","ref":"VertexCacheSdk.Command.Impl.SetCommand.html#execute/2"},{"type":"function","title":"VertexCacheSdk.Command.Impl.SetCommand.new/2","doc":"","ref":"VertexCacheSdk.Command.Impl.SetCommand.html#new/2"},{"type":"function","title":"VertexCacheSdk.Command.Impl.SetCommand.new/3","doc":"","ref":"VertexCacheSdk.Command.Impl.SetCommand.html#new/3"},{"type":"function","title":"VertexCacheSdk.Command.Impl.SetCommand.new/4","doc":"","ref":"VertexCacheSdk.Command.Impl.SetCommand.html#new/4"},{"type":"function","title":"VertexCacheSdk.Command.Impl.SetCommand.parse_response/1","doc":"Callback implementation for  VertexCacheSdk.Command.parse_response/1 .","ref":"VertexCacheSdk.Command.Impl.SetCommand.html#parse_response/1"},{"type":"type","title":"VertexCacheSdk.Command.Impl.SetCommand.t/0","doc":"","ref":"VertexCacheSdk.Command.Impl.SetCommand.html#t:t/0"},{"type":"module","title":"VertexCacheSdk.Model.ClientOption","doc":"Configuration container for initializing the VertexCache SDK client.\n\nThis struct holds all user-specified options required to establish a connection\nto a VertexCache server, including host, port, TLS settings, authentication tokens,\nencryption modes (asymmetric or symmetric), and related keys or certificates.\n\nIt provides a flexible way to customize client behavior, including security preferences.","ref":"VertexCacheSdk.Model.ClientOption.html"},{"type":"function","title":"VertexCacheSdk.Model.ClientOption.build_ident_command/1","doc":"Returns the IDENT command used to initiate a client handshake.","ref":"VertexCacheSdk.Model.ClientOption.html#build_ident_command/1"},{"type":"module","title":"VertexCacheSdk.Model.CommandResult","doc":"Represents the result of executing a cache command in the VertexCache SDK.\n\nThis struct encapsulates the response status and message returned from the server\nafter executing a command such as GET, SET, or DEL.\n\nIt is used by SDK consumers to inspect whether the command succeeded and to retrieve\nassociated values or error details. Convenience fields such as `:success` and `:status_message`\nhelp simplify response handling in client logic.","ref":"VertexCacheSdk.Model.CommandResult.html"},{"type":"module","title":"VertexCacheSdk.Model.EncryptionMode","doc":"Defines supported encryption modes for VertexCache SDK communication.\n\nModes:\n- :none - no encryption\n- :symmetric - shared secret encryption (e.g., AES-GCM)\n- :asymmetric - public/private key encryption (e.g., RSA)","ref":"VertexCacheSdk.Model.EncryptionMode.html"},{"type":"function","title":"VertexCacheSdk.Model.EncryptionMode.all/0","doc":"","ref":"VertexCacheSdk.Model.EncryptionMode.html#all/0"},{"type":"type","title":"VertexCacheSdk.Model.EncryptionMode.t/0","doc":"","ref":"VertexCacheSdk.Model.EncryptionMode.html#t:t/0"},{"type":"function","title":"VertexCacheSdk.Model.EncryptionMode.valid?/1","doc":"","ref":"VertexCacheSdk.Model.EncryptionMode.html#valid?/1"},{"type":"module","title":"VertexCacheSdk.Model.GetResult","doc":"Specialized result struct for handling GET command responses from VertexCache.\n\nExtends `CommandResult` by adding a `:value` field, which contains the actual\ncached value associated with the requested key, if present.\n\nThis struct is typically used when calling `VertexCacheSdk.get/1` to retrieve a value\nfrom the cache and determine its presence and contents.","ref":"VertexCacheSdk.Model.GetResult.html"},{"type":"exception","title":"VertexCacheSdk.Model.VertexCacheSdkException","doc":"Custom exception for VertexCache SDK, used for consistent cross-SDK error handling.","ref":"VertexCacheSdk.Model.VertexCacheSdkException.html"},{"type":"type","title":"VertexCacheSdk.Model.VertexCacheSdkException.t/0","doc":"","ref":"VertexCacheSdk.Model.VertexCacheSdkException.html#t:t/0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}